/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file antiflood.cpp
 * @brief AntiFlood implementation file
 */

#include "antiflood.h"

/**
 * Constructor
 */ 
AntiFlood::AntiFlood(BotKernel*b)
{
	this->author = "eponyme";
	this->description = "antiflood plugin";
	this->version = VERSION;
	this->name = "antiflood";
	this->bindFunction("",IN_BEFORE_TREATMENT,"testMsgTimestamp",0,10);
   this->addRequirement("admin");
}

extern "C"
{
	Plugin *contruct_antiflood(BotKernel*b)
	{
		return new AntiFlood(b);
	}
	void destroy_antiflood(Plugin*p)
	{
		delete p;
	}
	bool testMsgTimestamp (Message*m,Plugin*p,BotKernel*b)
	{
      pPlugin * ppAdm = b->getPlugin("admin");
      Admin*adm = NULL;
      if (ppAdm!=NULL) {
         adm = (Admin*)ppAdm->object ;
         string maxtime = b->getCONFF()->getValue(p->getName()+".maxtime");
         if ( (m->getPart(1) == "PRIVMSG") && (maxtime != "") && (maxtime != "0") && (m->getElapsedTime()>Tools::strToInt(maxtime)) ) {
            if ( ( b->getCONFF()->getValue(p->getName()+".allowsa") == "1") &&  adm->isSuperAdmin(m->getSender()) ) {
               return true;            
            }
            else {
               return false;
            }
         }
      }
		return true;
	}
}
