/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file fedorafr.h
 * @brief Fedorafr header file
 */

#ifndef FEDORAFR_H
#define FEDORAFR_H
#include "../plugin.h"
#include "../botkernel.h"
#include <iostream>
using namespace std;

/** @brief Class that provides stuff to search on Fedora-fr.org wiki or planet
 *
 * Class that provides stuff to search on Fedora-fr.org wiki or planet.
 * It connects the bot to Fedora-fr.org website, execute queries and parse result
 */

class Fedorafr : public Plugin
{
private:
public:
   /// Constructor
	Fedorafr(BotKernel*);
   /// Extract links in a wiki result page
   vector<string> getWikiLinks(string);
};


#endif

