/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file fedoraproject.h
 * @brief FedoraProject header file
 */

#ifndef FEDORAPROJECT_H
#define FEDORAPROJECT_H
#include "../plugin.h"
#include "../botkernel.h"
#include "admin.h"
#include "curl/curl.h" 
#include <fstream>
#include <map>
#include <iostream>
using namespace std;

/** @brief Plugin in connection with fedora project
 *
 * Plugin that provides tools to retrieve informations about fedora project
 */

class FedoraProject : public Plugin
{
private:
	/// FAS users infos
	map<string,vector<string> > usersInfos;
public:
   /// Constructor
	FedoraProject(BotKernel*);
   ///  writer call back function used by curl  
   static int writer(char *, size_t, size_t,string *) ;
   /// Tells who owns a package
   string whoowns(string);
	/// Load FAS file
	bool loadFasFile(string);
	/// get FAS user infos
	vector<string> getFasUserInfos(string);
};


#endif

