/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file magic8ball.h
 * @brief Magic8Ball header file
 */

#ifndef MAGIC8BALL_H
#define MAGIC8BALL_H
#include "../plugin.h"
#include "../botkernel.h"
#include <iostream>
using namespace std;

/** @brief magic 8 ball game
 *
 * Plugin simulating magic 8 ball game
 * see http://en.wikipedia.org/wiki/Magic_8-Ball
 */

class Magic8Ball : public Plugin
{
private:
   /// magic answers
   string answers[20];
public:
   /// Constructor
	Magic8Ball(BotKernel*);
   /// Return a random answer
   string getRandomAnswer();
};


#endif

