/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file ping.h
 * @brief Ping header file
 */

#ifndef PING_H
#define PING_H
#include "../plugin.h"
#include "../botkernel.h"
#include "time.h"
#include <iostream>
using namespace std;

/** @brief Manage ping events
 *
 * This class provides methods to manage
 * ping events and test connection with the server
 */

class Ping : public Plugin
{
private:
   /// Indicate if the server has sended a good pong
   bool ponged;
public:
   /// Construcor
	Ping(BotKernel*);
   /// Set ponged value 
   void setPonged(bool);
   /// Get ponged value
   bool getPonged();
};


#endif

