/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file pluginsample.cpp
 * @brief PluginSample implementation file
 */

#include "pluginsample.h"

/**
 * Constructor
 */ 
PluginSample::PluginSample(BotKernel*b)
{
	this->author = "my nick !";
	this->description = "My first plugin !!!";
	this->version = VERSION;
	this->name = "sample";
	this->bindFunction("hello",IN_COMMAND_HANDLER,"myFunction",0,2);
}

extern "C"
{
	Plugin *contruct_pluginsample(BotKernel*b)
	{
		return new PluginSample(b);
	}
	void destroy_pluginsample(Plugin*p)
	{
		delete p;
	}
	bool myFunction (Message*m,Plugin*p,BotKernel*b)
	{
		if ( m->isPublic()) {
			b->send(IRCProtocol::sendMsg(m->getSource(),"Hello "+m->getNickSender())) ;
      }
		else {
			b->send(IRCProtocol::sendMsg(m->getNickSender(),"Hello "+m->getNickSender())) ;
      }
		return true;
	}
}
