/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file postconnect.h
 * @brief PostConnect header file
 */

#ifndef POSTCONNECT_H
#define POSTCONNECT_H
#include "../plugin.h"
#include "../botkernel.h"

/** @brief Afer connect plugin
 *
 * This class plugin mamage all actions performed after 
 * server connection (join channels, auth to bots, and raw actions)
 */
class PostConnect : public Plugin
{
private:
   /// stores attempts number
   unsigned int nickRetreiveAttempts;

public:
   /// Constructor
	PostConnect(BotKernel*);
   /// get nick retreive attemtps
   unsigned int getNickRetreiveAttempts();
   /// Increase nick retreive attempts
   void bumpNickRetreiveAttempts();
   /// Rest nick retreive attempts
   void resetNickRetreiveAttempts();
};


#endif
