/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file slapme.cpp
 * @brief Slapme implementation file
 */

#include "slapme.h"

/**
 * Constructor
 */ 
Slapme::Slapme(BotKernel*b)
{
	this->author = "eponyme";
	this->description = "slaps users";
	this->version = VERSION;
	this->name = "slapme";
   this->bindFunction("slapme",IN_COMMAND_HANDLER,"slapme",0,10);
}

extern "C"
{
	Plugin *contruct_slapme(BotKernel*b)
	{
		return new Slapme(b);
	}
	void destroy_slapme(Plugin*p)
	{
		delete p;
	}
   bool slapUser(Message*m,Plugin*p,BotKernel*b)
   {
      b->send( IRCProtocol::sendAction(m->getSource(),"slaps "+m->getNickSender()+" : "+Tools::vectorToString(m->getSplit()," ",5)) ) ;
      return true;
   }
	bool slapme (Message*m,Plugin*p,BotKernel*b)
	{
      unsigned int seconds;
      if (m->isPublic() && (m->nbParts()>5) ) {   
         seconds = Tools::strtimeToSeconds(m->getPart(4)) ;
         if(b->addCountDown(p,slapUser,m,seconds,5)==NULL) {
            b->send(IRCProtocol::sendNotice(m->getNickSender(),"Error, too many count downs are running"));
         }
         else {
            b->send( IRCProtocol::sendNotice(m->getNickSender(),"slap in "+Tools::intToStr(seconds)+" seconds added."  ) );
         }
      }
		return true;
	}
}
