/*
#########################################################################
#
#  This file is part of trustyRC.
#
#  trustyRC, fully modular IRC robot 
#  Copyright (C) 2006-2008 Nicoleau Fabien 
#
#  trustyRC is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  trustyRC is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with trustyRC.  If not, see <http://www.gnu.org/licenses/>.
#
#########################################################################
*/

/** @file tele.cpp
 * @brief Tele implementation file
 */

#include "tele.h"

/**
 * Constructor
 */ 
Tele::Tele(BotKernel*b)
{
	this->author = "eponyme";
	this->description = "Display french TV program";
	this->version = VERSION;
	this->name = "tele";
	this->bindFunction("tele",IN_COMMAND_HANDLER,"tele",0,35);
	this->bindFunction("tv",IN_COMMAND_HANDLER,"tele",0,35);
}

extern "C"
{
	Plugin *contruct_tele(BotKernel*b)
	{
		return new Tele(b);
	}
	void destroy_tele(Plugin*p)
	{
		delete p;
	}
	bool tele(Message*m,Plugin*p,BotKernel*b)
	{
      const string HERTZ = "class=\"homeProgramHertz\">" ;
      const string TITLE = "title=\"";
      const string ALT = "alt=\"";
      const string END_CHANNEL = "</tr>";
      const string CHANNEL7 = "<tr id=\"ctl00_cphM_HP1_Repeater1_ctl07_trItem\"" ;
      string channel = "";
      string buffer;
      string::size_type pos ;
      unsigned int i = 0 ;
      Socket sock = Socket();
      if (m->isPublic())
      {
         if (!sock.connectSock(80,"www.telephant.com","")) {
            b->send(IRCProtocol::sendMsg(m->getSource(), "* Unable to connect to www.telephant.com *") );
            return true;
         }
         sock.sendStr("GET /programme-tv-en-ce-moment.html HTTP/1.1\nHost: www.telephant.com\n\n") ;
         while ((buffer.find(CHANNEL7)==string::npos)&&(buffer.find("</body>")==string::npos)) {
            buffer += sock.receive();
         }
         pos = buffer.find(HERTZ) ;
         if ( pos != string::npos) {
            buffer = buffer.substr(pos+HERTZ.length()) ;
            pos = buffer.find(TITLE); 
            while ( pos != string::npos) {
               buffer =  buffer.substr(buffer.find(ALT)+ALT.length());
               channel = buffer.substr(0,buffer.find("\"")) ;
               pos = buffer.find(TITLE);
               buffer = buffer.substr(pos+TITLE.length());
               b->send(IRCProtocol::sendMsg(m->getSource(),Tools::clearAccents(Tools::cleanHTML(channel+" : "+buffer.substr(0,buffer.find("\"")))))) ;
               buffer = buffer.substr(buffer.find(END_CHANNEL));
               pos = buffer.find(TITLE);
               i++;
            }
         }
         else {
            b->send(IRCProtocol::sendMsg(m->getSource(),"* Parse error *")) ;
         }
      }
		return true;
	}
}
